package com.ebtlocator;


import com.ebtlocator.Beacon;
import com.ebtlocator.Master;
import com.ebtlocator.Single;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

public class Initial extends Activity {

	private static final int REQUEST_ENABLE_BT = 1;
	   private Button onBtn;								//Turn on bluetooth button
	   private Button offBtn;								//Show available bluetooth device in area bluetooth button
	   private Button serverBtn;							//Turn off master mode button
	   private Button beaconBtn;							//Turn on beacon mode button
	   private Button singleBtn;							//List accessory of interface
	   private BluetoothAdapter myBluetoothAdapter;	
	   
	   @Override
	   protected void onCreate(Bundle savedInstanceState) {
	      super.onCreate(savedInstanceState);
	      setContentView(R.layout.activity_initial);
 
	      myBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
	      if(myBluetoothAdapter == null) {
	          onBtn.setEnabled(false);
	          offBtn.setEnabled(false);
	          serverBtn.setEnabled(false);
	          beaconBtn.setEnabled(false);
	          singleBtn.setEnabled(false);
	          Toast.makeText(getApplicationContext(),"Your device does not support Bluetooth",
	                 Toast.LENGTH_LONG).show();
	      } else {
	          
	    	   
	          onBtn = (Button)findViewById(R.id.turnOn);
	          onBtn.setOnClickListener(new OnClickListener() {

	            @Override
	            public void onClick(View v) {
	                on(v);
	            }
	          });

	          offBtn = (Button)findViewById(R.id.turnOff);
	          offBtn.setOnClickListener(new OnClickListener() {

	            @Override
	            public void onClick(View v) {
	                off(v);
	            }
	          });
	        	  
	        	  beaconBtn = (Button)findViewById(R.id.beacon);
		          beaconBtn.setOnClickListener(new OnClickListener() {

		            @Override
		            public void onClick(View v) {
		            	if (myBluetoothAdapter.isEnabled()) {
			            	Intent mi_intento = new Intent(Initial.this,Beacon.class);
			    			startActivity(mi_intento);	  
		            	}else
		            		Toast.makeText(getApplicationContext(),"ACTIVAR BLUETOOTH" ,
		     	                   Toast.LENGTH_LONG).show();
		            }
		          });
		       	 
		          serverBtn = (Button)findViewById(R.id.master);
		          serverBtn.setOnClickListener(new OnClickListener() {

		            @Override
		            public void onClick(View v) {
		            	if (myBluetoothAdapter.isEnabled()) {
			            	Intent mi_intento = new Intent(Initial.this,Master.class);
			    			startActivity(mi_intento);
		            	}else
		            		Toast.makeText(getApplicationContext(),"ACTIVAR BLUETOOTH" ,
			     	                   Toast.LENGTH_LONG).show();
		            }
		          });
		          
		          singleBtn = (Button)findViewById(R.id.single);
		          singleBtn.setOnClickListener(new OnClickListener() {

		            @Override
		            public void onClick(View v) {
		            	if (myBluetoothAdapter.isEnabled()) {
			            	Intent mi_intento = new Intent(Initial.this,Single.class);
			    			startActivity(mi_intento);
		            	}else
		            		Toast.makeText(getApplicationContext(),"ACTIVAR BLUETOOTH" ,
			     	                   Toast.LENGTH_LONG).show();
		            }
		            
		          });
		          
	           
	      }
	   }

	///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	                                      CLASS FUNCTIONS
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////


	 //TURN ON BLUETOOTH FUNCTION
	 //ENABLE THE BLUETOOTH ADAPTER OF DEVICE, REQUIRES MANUAL ACTION
	    
	    public void on(View view){
	        if (!myBluetoothAdapter.isEnabled()) {
	           Intent turnOnIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
	           startActivityForResult(turnOnIntent, REQUEST_ENABLE_BT);

	           Toast.makeText(getApplicationContext(),"BLUETOOTH ACTIVADO" ,
	                   Toast.LENGTH_LONG).show();
	        }
	        else{
	           Toast.makeText(getApplicationContext(),"BLUETOOTH YA SE ENCUENTRA ACTIVADO",
	                   Toast.LENGTH_LONG).show();
	        }
	     }
	    
	 //TURN OFF BLUETOOTH FUNCTION
	 //DISABLE THE BLUETOOTH ADAPTER OF DEVICE
	    
	   public void off(View view){
	      myBluetoothAdapter.disable();

	      Toast.makeText(getApplicationContext(),"BLUETOOTH DESACTIVADO",
	              Toast.LENGTH_LONG).show();
	   }
 

}