package com.ebtlocator;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.UUID;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothServerSocket;
import android.bluetooth.BluetoothSocket;
import android.content.Intent;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

public class Master extends Activity {

	   private Button serverBtn;							//Turn on master mode button
	   private Button outServerBtn;							//Turn off master mode button
	   private ListView myListMSG;							//List accessory of interface
	   private ListView myListLocations;					//List accessory of interface
	   private BluetoothAdapter myBluetoothAdapter;			//Bluetooth adapter to obtains self characteristic
	   private ArrayAdapter<String> BTArrayAdapter1;			//Adapter between list view and other generated lists
	   private ArrayAdapter<String> BTArrayAdapter2;			//Adapter between list view and other generated lists
	   private ArrayAdapter<BeaconData> finalDevArray;		//Generated list of information received from beacons
	   private ArrayAdapter<Coordinates> locationList;
	   private BluetoothSocket mBluetoothSocket = null;		//Communication bluetooth socket
	   private UUID bluetoothUUID = UUID.fromString("00001111-0000-1000-18000-001011111111");	//Required key for socket connection						//
	   private String message = "blank";					//Initialization of interchanged message
	   
	   @Override
	   protected void onCreate(Bundle savedInstanceState) {
	      super.onCreate(savedInstanceState);
	      setContentView(R.layout.activity_master);

	      // take an instance of BluetoothAdapter - Bluetooth radio
	      myBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
	     

	          myListMSG = (ListView)findViewById(R.id.listViewMSG);
	          myListLocations = (ListView)findViewById(R.id.listViewLocations);

	          finalDevArray = new ArrayAdapter<BeaconData>(this, android.R.layout.simple_list_item_1);
	          locationList = new ArrayAdapter<Coordinates>(this, android.R.layout.simple_list_item_1);
	          
	          BTArrayAdapter1 = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1);
	          BTArrayAdapter2 = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1);
	          
	          myListMSG.setAdapter(BTArrayAdapter1);
	          myListMSG.setOnItemClickListener(new OnItemClickListener() {
	  			
	  			@Override
	  			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
	  					
	  			}
	  		  });
	          
	          myListLocations.setAdapter(BTArrayAdapter2);
	          myListLocations.setOnItemClickListener(new OnItemClickListener() {
		  			
		  			@Override
		  			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
		  					
		  			}
		  	  });
	          
	          final CountDownTimer serverTimer = new CountDownTimer(11000, 500) {
	       		 
	       	     public void onTick(long millis_to_end) {
	       	        
	             	AcceptThread accept = new AcceptThread("miServidor");

		            accept.run();

		            extractMatrix(message);

		            BTArrayAdapter1.clear();
		            for(int i = 0 ; i < finalDevArray.getCount() ; ++i) {
		            	
		            	String cad1 = finalDevArray.getItem(i).getOrigin() + " " + finalDevArray.getItem(i).getMac() + " " + finalDevArray.getItem(i).getSig();
		            	BTArrayAdapter1.add(cad1);
		            	BTArrayAdapter1.notifyDataSetChanged();

		            	BeaconData tempDev = new BeaconData(finalDevArray.getItem(i).getOrigin(), finalDevArray.getItem(i).getMac(), finalDevArray.getItem(i).getSig());
		            	if(finalDevArray.getCount() > 1)
			            	for(int j = 1 ; j < finalDevArray.getCount() ; ++j) {

			            		if(tempDev.getOrigin() != finalDevArray.getItem(j).getOrigin() & tempDev.getMac().equals(finalDevArray.getItem(j).getMac())) {
			            			int tempDist = 0;
			            			int tempRad1 = 0, tempRad2 = 0;

			            			if(tempDev.getOrigin() > finalDevArray.getItem(j).getOrigin()) {
			            				tempDist = tempDev.getOrigin();
			            				tempRad2 = tempDev.getSig();
			            				tempRad1 = finalDevArray.getItem(j).getSig();	
			            			}else {
			            				tempDist = finalDevArray.getItem(j).getOrigin();
			            				tempRad2 = finalDevArray.getItem(j).getSig();
			            				tempRad1 = tempDev.getSig();
			            			}

			            			obtainCordinates(finalDevArray.getItem(j).getMac(), tempDist, tempRad1, tempRad2);
			            			break;
			            		}
			            	}
		            }
		            
//		            if(!locationList.isEmpty())
//			            for(int i = 0 ; i < locationList.getCount() ; ++i) {
//			            	String cad2 = locationList.getItem(i).getMac() + " (" + locationList.getItem(i).getXposition() + "," + locationList.getItem(i).getYposition() + ")";
//			            	BTArrayAdapter2.add(cad2);
//			            	BTArrayAdapter2.notifyDataSetChanged();
//			            } 
		            
	       	     }
	       	 
	       	     public void onFinish() {
	       	    	 this.start();
	       	     }
	       	  };
	          
	       	  serverTimer.start();
	       	  
	          outServerBtn = (Button)findViewById(R.id.cancelMaster);
	          outServerBtn.setOnClickListener(new OnClickListener() {

	            @Override
	            public void onClick(View v) {
	               serverTimer.cancel();
	               BTArrayAdapter1.clear();
	               finalDevArray.clear();
	               
	               BTArrayAdapter2.clear();
	               
	               Intent mi_intento = new Intent(Master.this,Initial.class);
	    			startActivity(mi_intento);
	            }
	          });
	          
	      }
	   

	///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	                                      CLASS FUNCTIONS
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////

	 //MESSAGE MANAGE AND STORAGE FUNCTION
	 //IF THE IMPUT MESSAGE CONTAINS OR BEGINS WITH '/' READS THE COMPLETE MESSAGE
	 //IF THE CHARACTER IS '%' MEANS THAT THE NEXT INFORMATION IS THE NAME OF THE BEACON TRANSMITTER
	 //IF THE CHARACTER IS '$' MEANS THAT THE NEXT INFORMATION IS THE ADDRESS OF THE FOUND DEVICE
	 //IF THE CHARACTER IS '&' MEANS THAT THE NEXT INFORMATION IS THE DISTANCE OF THE FOUND DEVICE
	 //IF THE CHARACTER IS '/' MEANS THAT THE NODE INFORMATION (BEACON, DEVICE ADDRESS, DISTANCE) IS READY TO STORE IN FINALDEVICELIST
	   
	   public void extractMatrix(String msg) {
		   
		 String tempBeacon = "";
	   	 String tempAddress = "";
	   	 String tempDist = "";
	   	 int typeData = 0;
	   	 int devicePointer;
	   	 boolean deviceHere;
	   	 
	   	 if(msg.contains("/")) {   	
	         for (int i = 0; i < msg.length(); ++i ) {
	         	if( msg.charAt (i) == '%')		//tipo de dato baliza
	         		typeData = 1;
	         	else if( msg.charAt (i) == '$')	//tipo de dato mac device address
	         		typeData = 2;
	         	else if( msg.charAt (i) == '&')	//tipo de dato rssi device
	         		typeData = 3;
	         	else if( msg.charAt (i) == '/')	//tipo de dato rssi device
	         		typeData = 4;
	         	
	         	if(typeData == 1 & msg.charAt (i) != '%') 
	         		tempBeacon = tempBeacon + msg.charAt (i);
	         	else if(typeData == 2 & msg.charAt (i) != '$') 
	         		tempAddress = tempAddress + msg.charAt (i);
	         	else if(typeData == 3 & msg.charAt (i) != '&') 
	         		tempDist = tempDist + msg.charAt (i);

	         	if(msg.charAt (i) == '/' & i != 0) {	//Carga datos en matriz
	         		devicePointer = 0;
	         		deviceHere = false;
	         		
//	         		Comprueba si el dispositivo ya esta registrado en la matriz
	         		for(int m = 0; m < finalDevArray.getCount() ; ++m) {
	         			if(Integer.parseInt(tempBeacon) == finalDevArray.getItem(m).getOrigin() & tempAddress.equals(finalDevArray.getItem(m).getMac())) {
	         				deviceHere = true;
	         				devicePointer = m;
	         			}
	                }
	         		
	         		tempBeacon.trim();
	         		tempAddress.trim();
	         		tempDist.trim();
	         		
	         		if(!deviceHere ) 
	         			finalDevArray.add(new BeaconData(Integer.parseInt(tempBeacon),tempAddress,Integer.parseInt(tempDist)));
	         		if(deviceHere) 
	         			finalDevArray.getItem(devicePointer).setSig(Integer.parseInt(tempDist));
	         		
	         		tempBeacon = "";
	         	   	tempAddress = "";
	         	   	tempDist = "";
	         	   	typeData = 0;
	         	}
	         		
	         }
	         
	         
	   	 }
	   	 
	   }
	   
	   public void obtainCordinates(String devMAC, int beaconsDist, int rad1, int rad2) {
		   
		   long x = 0;
		   long y = 0;
		   
		   if(rad1 + rad2 <= beaconsDist)
			   locationList.add(new Coordinates(devMAC, rad1, 0));
		   else {
			   double tempSemiperiod = 0;
			   double tempArea = 0;
			   
			   tempSemiperiod = (rad1 + rad2 + beaconsDist)/2;
			   tempArea = Math.sqrt(Math.abs(tempSemiperiod*(tempSemiperiod - rad1)*(tempSemiperiod - rad2)*(tempSemiperiod - beaconsDist)));
			   
			   y = Math.round(tempArea*2/beaconsDist);
			   
			   x = Math.round(rad1 * Math.cos(Math.asin(y/rad1)));
			   
			   if(x>0 & !locationList.isEmpty()) {
				   for(int i = 0; i < locationList.getCount() ; ++i) {
					   if(locationList.getItem(i).getMac().equals(devMAC)) {
						   
						   BTArrayAdapter2.remove(BTArrayAdapter2.getItem(i));
						   BTArrayAdapter2.add(devMAC + " (" + x + "," + y + ")");
						   BTArrayAdapter2.notifyDataSetChanged();
						   
						   locationList.remove(locationList.getItem(i));
						   locationList.add(new Coordinates(devMAC, x, y));
						   
						   break;
					   }
					   if(i == locationList.getCount()-1) {
						   BTArrayAdapter2.add(devMAC + " (" + x + "," + y + ")");
						   BTArrayAdapter2.notifyDataSetChanged();
						   
						   locationList.add(new Coordinates(devMAC, x, y));
					   }
				   }
			   }else if(x>0 & locationList.isEmpty()) {
				   BTArrayAdapter2.add(devMAC + " (" + x + "," + y + ")");
				   BTArrayAdapter2.notifyDataSetChanged();
				   
				   locationList.add(new Coordinates(devMAC, x, y));
			   }
		   }
			   
	   }


	///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	                                     COMMUNICATION CLASSES
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////

	//SERVER CLASS
	//CONSTRUCTOR 	:	CREATE A BLUETOOTH SERVER SOCKET
	//RUN			:	ACCEPT A CLIENT COMM / SEND A MESSAGE IF SOMEONE IS LISTENING / RECEIVE A MESSAGE FROM CLIENT / CLOSE SOCKETS
	//CLOSE	 		: 	CANCEL THE SERVER SOCKET

	private class AcceptThread extends Thread {

	  private BluetoothServerSocket mServerSocket;

	  public AcceptThread(String name) {
		  mServerSocket = null;
		  try {
		      mServerSocket = myBluetoothAdapter.listenUsingRfcommWithServiceRecord(name, bluetoothUUID);
		  } catch (IOException e) {
			  Toast.makeText(getApplicationContext(),"Server NOT AVAILABLE" ,
	                  Toast.LENGTH_LONG).show();
		  }
	  }

	  public void run() {

		  while (mServerSocket!=null) {
		      try {
		            	
		    	  mBluetoothSocket = mServerSocket.accept();
		          if (mBluetoothSocket != null) {
		        	  StreamThread mStreamThread = new StreamThread();
		              mStreamThread.start();
		                    
			          String a = message;
			          byte[] data = a.getBytes();
			          mStreamThread.write(data);
		                    
		              message = mStreamThread.read();
		              try {
		            	  mBluetoothSocket.close();
		              } catch (IOException e) {}
		                	
		              try {
		            	  mServerSocket.close();
		              } catch (IOException e) {}
		              	  mServerSocket = null;
		          }
		                
		          } catch (IOException e) {
		        	  Toast.makeText(getApplicationContext(),"Server NOT accept a client" ,
		        			  Toast.LENGTH_LONG).show();}
		          break;
		  }
	  }

	}

	//STREAM CLASS
	//CONSTRUCTOR 	:	CREATE A COMMUNICATIONS STREAMS (BUFFERS) INPUT AND OUTPUT
	//READ			:	EXTRACT BYTES FROM IN BUFFER AND SAVE IN A STRING VARIABLE
	//WRITE	 		: 	WRITE BYTES IN THE OUT BUFFER

	private class StreamThread extends Thread {

	    private InputStream in;
	    private OutputStream out;

	    public StreamThread() {
	        try {
	            in = mBluetoothSocket.getInputStream();
	            out = mBluetoothSocket.getOutputStream();
	        } catch (IOException e) {}
	    }

	    public String read() {
	        byte[] data = new byte[30000];
	        int length;
	        String text = null;
	        while (true) {
	            try {
	                length = in.read(data);
	                text = new String(data, 0, length);
	                 
	            } catch (IOException e) {
	            	text = "Empty buffer";   
	            }
	            break;
	        }
	        return text;
	     }

	     public void write(byte[] data) throws IOException {
	    	try {
	    		out.write(data);
	           }catch (Exception e) {}
	     }
	}
	   
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//						                 DATA MANAGE CLASSES
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////

	//INFO FROM BEACONS CLASS
	//CONSTRUCTOR 	:	INITIALIZE WHITH TRANSMITTER NAME, ADDRESS OF FOUN DEVICE AND ITS DISTANCE TO TRANSMITTER
	//GETS			:	OBTAINS THE EXPLICIT OBJECT
	//SETS			:	ASSIGNS THE VALUE OF A EXPLICIT OBJECT   
	   
	private class BeaconData {
		   
		private int origin;
		private String mac;
		private int distance;
		
	    public BeaconData(int name, String macadd, int signal) {
	    	origin = name;
	        mac = macadd;
	        distance = signal;
	    }
	       
	    public void setOrigin(int name) {
	    	origin = name;
	    }
	    
	    public int getOrigin() {
	    	return origin;
	    }
	       
	    public void setMac(String macadd) {
	    	mac = macadd;
	    }
	       
	    public String getMac() {
	    	return mac;
	    }
	       
	    public void setSig(int sig) {
	    	distance = sig;
	    }
	       
	    public int getSig() {
	    	return distance;
	    }
	}
	
	private class Coordinates{
		private long x, y;
		private String device;
		
		public Coordinates(String objet, long x, long y) {
			device = objet;
			this.x = x;
			this.y = y;
		}
		
		public long getXposition() {
			return x;
		}
		
		public long getYposition() {
			return y;
		}
		
		public String getMac() {
			return device;
		}
	}

}
