package com.ebtlocator;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Comparator;
import java.util.Set;
import java.util.UUID;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothServerSocket;
import android.bluetooth.BluetoothSocket;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

public class Single extends Activity {
	private static final int REQUEST_ENABLE_BT = 1;
	   private Button findBtn;								//Show available bluetooth device in area bluetooth button
	   private ListView myListView;							//List accessory of interface
	   private BluetoothAdapter myBluetoothAdapter;			//Bluetooth adapter to obtains self characteristic
	   private ArrayAdapter<String> BTArrayAdapter;
	   
	   @Override
	   protected void onCreate(Bundle savedInstanceState) {
	      super.onCreate(savedInstanceState);
	      setContentView(R.layout.activity_single);

	      // take an instance of BluetoothAdapter - Bluetooth radio
	      myBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
	      if(myBluetoothAdapter == null) {
	          findBtn.setEnabled(false);

	          Toast.makeText(getApplicationContext(),"Your device does not support Bluetooth",
	                 Toast.LENGTH_LONG).show();
	      } else {
	          
	          findBtn = (Button)findViewById(R.id.search);
	          findBtn.setOnClickListener(new OnClickListener() {

	            @Override
	            public void onClick(View v) {
	                find();
	            }
	          });
	          
	          myListView = (ListView)findViewById(R.id.listView1);

	          // create the arrayAdapter that contains the BTDevices, and set it to the ListView
	          BTArrayAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1);
	          myListView.setAdapter(BTArrayAdapter);
	          
	          
	      }
	   }

	///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	                                      CLASS FUNCTIONS
	///////////////////////////////////////////////////////////////////////////////////////////////////////////////


	 //FOUND DEVICES LIST FUNCTION
	 //START DISCOVERY MODE OF THE BLUETOOTH ADAPTER AND INITIALIZE THE ARRAYS AND THE MESSAGE TO SEND
	 //ACTIVATE REGISTER-RECEIVER TO FOUND DEVICES IN AREA
	   
	   public void find() {
	       if (myBluetoothAdapter.isDiscovering()) {
	           // the button is pressed when it discovers, so cancel the discovery
	           myBluetoothAdapter.cancelDiscovery();
	       }
	       else {
	            BTArrayAdapter.clear();

	            myBluetoothAdapter.startDiscovery();

	            registerReceiver(bReceiver, new IntentFilter(BluetoothDevice.ACTION_FOUND));    
	        }    
	   }
	 
	 //BROADCAST RECEIVER (LISTENER) FUNCTION
	 //WAIT FOR INCOMMING DEVICE IN AREA (ACTION_FOUND)
	 //REGISTER THE DEVICE CHARACTERISTICS (EXTRA_DEVICE AND EXTRA_RSSI)
	 //STORAGE IN DEVICELIST IF IT NOT EXISTS IN THE LIST, IF IT EXISTS, ONLY CHANGE THE RSSI VALUE
	 //ADD INFORMATION AT THE MASSAGE TO SEND 
	   
	   final BroadcastReceiver bReceiver = new BroadcastReceiver() {
	        public void onReceive(Context context, Intent intent) {
	            String action = intent.getAction();

	            if (BluetoothDevice.ACTION_FOUND.equals(action)) {
	            	
	                 BluetoothDevice device = intent.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
			         int rssi = intent.getShortExtra(BluetoothDevice.EXTRA_RSSI,Short.MIN_VALUE);
			         
			         BTArrayAdapter.add(device.getName() + "\n" + device.getAddress() + "\n" + String.valueOf(rssi));
			       	 BTArrayAdapter.notifyDataSetChanged();
	            }
	        }
	    };


	 //DESTROY FUNCTION
	 //DESTROY RECEIVER
	   
	   @Override
	   protected void onDestroy() {
	       // TODO Auto-generated method stub
	       super.onDestroy();
	       unregisterReceiver(bReceiver);
	   }

}
